﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr260_1
{
    // Обобщенный интерфейс:
    interface MyInterface<X, Y> { 
        void set(X a, Y b); 
        void show();
    }

    // Обобщенный класс реализует обобщенный интерфейс: 
    class Alpha<X, Y>: MyInterface<X, Y> { 
        private X first; 
        private Y second; 
        public void set(X a, Y b) { 
            first = a; 
            second = b;
        }
        public void show() {
            Console.WriteLine("Поля {0} и {1}", first, second);
        }
    }

    // Обобщенный класс реализует обобщенный интерфейс: 
    class Bravo<Y>: MyInterface<int, Y> { 
        private int first; 
        private Y second; 
        public void set(int a, Y b) { 
            first = a; 
            second = b;
        }
        public void show() {
            Console.WriteLine("Поля {0} и {1}", first, second);
        }
    }

    // Обычный класс реализует обобщенный интерфейс: 
    class Charlie: MyInterface<int, char> { 
        private int first; 
        private char second;
        public void set(int a, char b) { 
            first = a; 
            second = b;
        }
        public void show() {
            Console.WriteLine("Поля {0} и {1}", first, second);
        }
    }

    // Главный класс: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            Console.WriteLine("Первый объект");
            // Создание объекта на основе обобщенного класса: 
            Alpha<string, double> A = new Alpha<string, double>(); 
            // Использование интерфейсной переменной: 
            MyInterface<string, double> Ra = A;
            // Вызов методов:
            A.set("Alpha", 100.0);
            Ra.show();
            Ra.set("alpha", 150.0);
            A.show();
            Console.WriteLine("Bтopoй объект");
            // Создание объекта на основе обобщенного класса: 
            Bravo<string> B = new Bravo<string>();
            // Использование интерфейсной переменной: 
            MyInterface<int, string> Rb = B;
            // Вызов методов:
            B.set(200, "Bravo");
            Rb.show();
            Rb.set(250, "bravo");
            B.show();
            Console.WriteLine("Третий объект");
            // Создание объекта на основе обычного класса:
            Charlie C = new Charlie();
            // Использование интерфейсной переменной:
            MyInterface<int, char> Rc = C;
            // Вызов методов:
            C.set(300, 'C');
            Rc.show();
            Rc.set(350, 'D');
            C.show();
            // Задержка:
            Console.ReadLine();
        }
    }
}
